tema-14-consultas-API/frontend/main/forms/professor_form.py
# - *- coding: utf- 8 - *-
from flask_wtf import FlaskForm #Importa funciones de formulario
from wtforms import PasswordField, SubmitField, StringField #Importa campos
from wtforms.fields.html5 import EmailField,DateField #Importa campos HTML
from wtforms import validators #Importa validaciones

class ProfessorForm(FlaskForm):

    #Definición de campo String
    firstname = StringField('Firstname',
    [
        #Definición de validaciones
        validators.Required(message = "Firstname is required"),
        validators.Length(min=5)
    ])

    lastname = StringField('Lastname',
    [
        validators.Required(message = "Lastname is required"),
        validators.Length(min=5)
    ])

    #Definición de campo de mail
    email = EmailField('E-mail',
    [
        validators.Required(message = "E-mail is require"),
        validators.Email( message ='Formad not valid'),
    ])

    #Definición de campo de contraseña
    password = PasswordField('Password', [
        validators.Required(),
         #El campo de contraseña debe coincidir con el de confirmuar
        validators.EqualTo('confirm', message='Passwords dont match')
    ])

    confirm = PasswordField('Repeat Password')

    fechaNac = DateField('Fecha Nacimiento',
        [
            validators.Required()
        ], format='%Y-%m-%d',)

    #Definición de campo submit
    submit = SubmitField("Send")

tema-14-consultas-API/frontend/main/forms/project_form.py
# - *- coding: utf- 8 - *-
from flask_wtf import FlaskForm #Importa funciones de formulario
from wtforms import PasswordField, SubmitField, StringField, SelectField, HiddenField#Importa campos
from wtforms.fields.html5 import EmailField, DateTimeField #Importa campos HTML
from wtforms import validators #Importa validaciones

class ProjectForm(FlaskForm):

    #Definición de campo String
    name = StringField('Name',
    [
        #Definición de validaciones
        validators.Required(message = "Name is required")
    ])

    year = DateTimeField('Year', format='%Y')

    professorId = SelectField('Leader Professor', coerce=int)

    professorInscr1Id = SelectField('Professor 1', coerce=int)

    professorInscr2Id = SelectField('Professor 2', coerce=int)

    professorInscr3Id = SelectField('Professor 3', coerce=int)
    #Definición de campo submit
    submit = SubmitField("Send")

tema-14-consultas-API/frontend/main/routes/professor.py
from flask import Blueprint, render_template, redirect, url_for, current_app
# Importar objeto Form
from ..forms.professor_form import ProfessorForm
# Importar librería request para realizar consulta y json para manejar la estructura de datos
import requests, json

#Crear Blueprint
professor = Blueprint('professor', __name__, url_prefix='/professor')

@professor.route('/')
def index():
    data = {}
    data['page'] = 1
    # Generar consulta GET al endpoint
    r = requests.get(
        current_app.config["API_URL"]+'/professors',
        headers={"content-type":"application/json"},
        data = json.dumps(data))
    #Convertir respuesta de JSON a  diccionario
    professors = json.loads(r.text)["professors"]
    #Mostrar template
    return render_template('professor_list.html', professors=professors )

@professor.route('/view/<int:id>')
def view(id):
    # Generar consulta GET al endpoint
    # Agregar cabecera
    r = requests.get(
        current_app.config["API_URL"]+'/professor/'+str(id),
        headers={"content-type":"application/json"})
    # Verificar código de respuesta
    if(r.status_code==404):
        # Si el recurso no existe redireccionar
        return redirect(url_for('professor.index'))
    #Convertir respuesta de JSON a  diccionario
    professor = json.loads(r.text)
    #Mostrar template
    return render_template('professor_view.html',professor=professor  )

@professor.route('/create', methods=["POST","GET"])
def create():
    form = ProfessorForm() #Instanciar formulario
    if form.validate_on_submit(): #Si el formulario ha sido enviado y es validado correctamente
        data = {}
        data["firstname"] = form.firstname.data
        data["lastname"] = form.lastname.data
        data["email"] = form.email.data
        data["password"] = form.password.data
        data["fechaNac"] = form.fechaNac.data.strftime("%Y-%m-%d")
        print(data)
        headers = {
        'content-type': "application/json"
        }
        r = requests.post(
            current_app.config["API_URL"]+'/professors',
            headers = headers,
            data = json.dumps(data))
        return redirect(url_for('professor.index')) #Redirecciona a lista
    return render_template('professor_form.html', form = form) #Muestra el formulario

tema-14-consultas-API/frontend/main/routes/project.py
from flask import Blueprint, render_template, current_app, redirect, url_for, current_app
# Importar objeto Form
from ..forms.project_form import ProjectForm
# Importar librería request para realizar consulta y json para manejar la estructura de datos
import requests, json

project = Blueprint('project', __name__, url_prefix='/project')

@project.route('/')
def index():
    data = {}
    data['page'] = 1
    #Crear headers
    headers = {
    'content-type': "application/json",
    }
    #Obtener proyects
    r = requests.get(
        current_app.config["API_URL"]+'/projects',
        headers = headers,
        data = json.dumps(data))
    #Cargar proyectos
    projects = json.loads(r.text)["projects"]
    #Mostrar template
    return render_template('project_list.html', projects=projects)

@project.route('/view/<int:id>')
def view(id):
    r = requests.get(
        current_app.config["API_URL"]+'/project/'+str(id),
        headers={"content-type":"application/json"})
    if(r.status_code==404):
        return redirect(url_for('project.index'))
    project = json.loads(r.text)
    #Mostrar template
    return render_template('project_view.html', project=project)

@project.route('/create', methods=["POST","GET"])
def create():
    #Instanciar formulario
    form = ProjectForm()
    # Obtener profesores
    data = {}
    data['page'] = 1
    r = requests.get(
            current_app.config["API_URL"]+'/professors',
            headers={"content-type":"application/json"},
            data = json.dumps(data))
    professors = [(item['id'], item['lastname']+" "+item['firstname']) for item in json.loads(r.text)["professors"]]
    inscriptions_p = [(item['id'], item['lastname']+" "+item['firstname']) for item in json.loads(r.text)["professors"]]

    # Cargar profesores en campo de formulario
    form.professorId.choices = professors
    inscriptions_p.insert(0, (0, ""))
    form.professorInscr1Id.choices = inscriptions_p
    form.professorInscr2Id.choices = inscriptions_p
    form.professorInscr3Id.choices = inscriptions_p
    if form.validate_on_submit(): #Si el formulario ha sido enviado y es validado correctamente
        headers = {
        'content-type': "application/json"
        }
        # Cargar datos del formulario
        data = {}
        data["name"] = form.name.data
        data["year"] = form.year.data.year
        data["professorId"] = form.professorId.data
        inscriptions = []
        if form.professorInscr1Id.data != 0:
            inscriptions.append({"professorId":form.professorInscr1Id.data})
        if form.professorInscr2Id.data != 0:
            inscriptions.append({"professorId":form.professorInscr2Id.data})
        if form.professorInscr3Id.data != 0:
            inscriptions.append({"professorId":form.professorInscr3Id.data})
        data["inscriptions"] = inscriptions
        # Crear solicitud POST
        r = requests.post(
            current_app.config["API_URL"]+'/projects',
            headers = headers,
            data = json.dumps(data))
        if(r.status_code==201):
            return redirect(url_for('project.index')) #Redirecciona a lista
    return render_template('project_form.html', form = form) #Muestra el formulario

tema-14-consultas-API/frontend/main/templates/macros/form.html
<!-- Macro que se encarga de mostrar los errores de validación -->
{% macro show_error(field) %}
	{% if field.errors %} <!--Si existen errores -->
	  <div class="alert alert-danger" role="alert">
	  {% for error in field.errors %} <!--Recorrer errrores-->
	   	{{ error }}<br><!--Mostrar error -->
	  {% endfor %}
	  </div>
	{% endif %}
{% endmacro %}

<!-- Macro que se encarga de mostrar los campos del formulario -->
{% macro show_field(field) %}
	{{ field.label }} <!-- Mostrar etiqueta -->
	{{ field(**kwargs)|safe }} <!-- Mostrar campo -->
	{{show_error(field)}}  <!-- Llamar a macro que muestra el error -->
{% endmacro %}

<!-- Macro que se encarga de mostrar los campos tipo submit formulario -->
{% macro show_submit(field) %}
	{{ field(**kwargs)|safe }} <!-- Mostrar campo -->
{% endmacro %}

tema-14-consultas-API/frontend/main/templates/macros/professor.html
<!-- Define la función para mostrar profesor -->
{% macro show_row_professor(professor) %}
<tr>
  <td>{{professor.firstname}}</td>
  <td>{{professor.lastname}}</td>
  <td>{{professor.email}}</td>
  <td>
    <a type="button" href="{{url_for('professor.view',id=professor.id)}}" class="btn btn-success">View</a>
  </td>

</tr>
{% endmacro %}

{% macro show_card_professor(professor) %}
<div class="card" style="width: 18rem;">
    <!-- Mostrar elemento estático -->
    <img src="{{url_for('static', filename='img/user.png')}}" style="width: 50%;right: 10%;position: relative;left: 20%;" alt="User image">
      <ul class="list-group list-group-flush">
        <li class="list-group-item"><b>Firstname: </b>{{professor.firstname}}</li>
        <li class="list-group-item"><b>Lastname: </b>{{professor.lastname}}</li>
        {% if professor.private %}
            <li class="list-group-item muted"><b>E-mail: </b>E-mail Private</li>
        {% else %}
            <li class="list-group-item"><b>E-mail: </b>{{professor.email}}</li>
        {% endif %}
      </ul>
      {%  if professor.projects %}
      <ul class="list-group list-group-flush">
        <li class="list-group-item"><b>Projects</b></li>
        {% for project in professor.projects %}
        <li class="list-group-item">{{project.name}} - {{project.year}}</li>
        {% endfor %}
      {% endif %}
      </ul>
</div>
{% endmacro %}

tema-14-consultas-API/frontend/main/templates/macros/project.html
{% macro show_project(project) %}
<tr>
  <td>{{project.id}}</td>
  <td>{{project.name}}</td>
  <td>{{project.year}}</td>
  <td>{{project.professor.firstname}} {{project.professor.lastname}}</td>
  <td>
    <a type="button" href="{{url_for('project.view',id=project.id)}}" class="btn btn-success">View</a>
  </td>
</tr>
{% endmacro %}

{% macro show_card_project(project) %}
<div class="card" style="width: 18rem;">
     <ul class="list-group list-group-flush">
        <li class="list-group-item"><b>Name: </b>{{project.name}}</li>
        <li class="list-group-item"><b>Year: </b>{{project.year}}</li>
        <li class="list-group-item"><b>Professor: </b>{{project.professor.firstname}} {{project.professor.lastname}}</li>
      </ul>
      {%  if project.inscriptions %}
      <ul class="list-group list-group-flush">
        <li class="list-group-item"><b>Inscriptions</b></li>
        {% for inscription in project.inscriptions %}
        <li class="list-group-item">{{inscription.professor.firstname}} {{inscription.professor.lastname}}</li>
        {% endfor %}
      {% endif %}
</div>
{% endmacro %}